#include "stdafx.h"

#include <windowsx.h>
#include <commctrl.h>

#include "resource.h"
#include "Util.h"
#include "ProgressDlg.h"

////////////////////////////////////////////////////////////////////////
// i\EBhE
////////////////////////////////////////////////////////////////////////

// g̃CX^X
CProgressDlg* CProgressDlg::s_pThis;

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CProgressDlg::CProgressDlg(int stepMax, const char* caption) :
	m_step(0),
	m_stepMax(stepMax),
	m_hDlg(0),
	m_hWndParent(0),
	m_caption(caption),
	m_bCancel(false)
{
	// NOTE: !!!!!!!!!!
	//       CProgressDlg ̃CX^Xx 2 ȏg
	//       낵ƂɂȂB
	s_pThis = this;
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CProgressDlg::~CProgressDlg()
{
}

//----------------------------------------------------------------------
// EBhE\ 
//----------------------------------------------------------------------

bool CProgressDlg::Show(HWND hWndParent)
{
	m_hWndParent = hWndParent;

	// eEBhE𖳌ɂ
	EnableWindow(m_hWndParent, FALSE);

	// i\p̃EBhE\邽߂̃Xbh쐬
	HANDLE hThread = CreateThread(0, 0, DialogThread, this, 0, 0);
	if (!hThread) {
		// eEBhELɂ
		EnableWindow(m_hWndParent, TRUE);

		return false;
	}

	// nh͕svȂ̂ŕ
	CloseHandle(hThread);

	return true;
}

//----------------------------------------------------------------------
// i\
//----------------------------------------------------------------------

void CProgressDlg::StepIt()
{
	++m_step;
	SetStep(m_step);
}

//----------------------------------------------------------------------
// I\
//----------------------------------------------------------------------

void CProgressDlg::TerminateStep(const char* progressMsg)
{
	DoEvents();

	// ieLXgݒ肷
	HWND hProgressText = GetDlgItem(m_hDlg, IDC_PROGRESS_TEXT);
	SendMessage(hProgressText, WM_SETTEXT, 0, (LPARAM) progressMsg);
	
	PostMessage(m_hDlg, WM_COMMAND, MAKEWPARAM(0, WM_TERMINATE_PROCESS_DIALOG), 0);

	DoEvents();
}

//----------------------------------------------------------------------
// LZꂽ𓾂
//----------------------------------------------------------------------

bool CProgressDlg::IsCancel()
{
	DoEvents();

	if (m_bCancel) {
		return true;
	}

	return false;
}

//----------------------------------------------------------------------
// I
//----------------------------------------------------------------------

void CProgressDlg::Hide()
{
	DoEvents();

	if (m_hDlg) {
		PostMessage(m_hDlg, WM_COMMAND, MAKEWPARAM(0, WM_CLOSE_PROCESS_DIALOG), 0);
	}
	EnableWindow(m_hWndParent, TRUE);
}

//----------------------------------------------------------------------
// _CAOvV[W(]p)
//----------------------------------------------------------------------

BOOL CALLBACK CProgressDlg::DialogProcStatic(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// _CAO\Xbh
//----------------------------------------------------------------------

DWORD WINAPI CProgressDlg::DialogThread(LPVOID pParam)
{
	CProgressDlg* pDlg = (CProgressDlg*) pParam;

	return CResourceManager::DlgBox(MAKEINTRESOURCE(IDD_PROGRESS_DLG), 0, DialogProcStatic);
}

//----------------------------------------------------------------------
// _CAOvV[W
//----------------------------------------------------------------------

BOOL CProgressDlg::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
	HANDLE_MSG(hWnd, WM_CLOSE, OnClose);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL CProgressDlg::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// _CAÕnhۑ
	//
	m_hDlg = hWnd;

	//
	// _CAO𒆉ɕ\
	//
	Util::CenterWindow(m_hWndParent, hWnd);

	//
	// s
	//

	// ^Cgݒ肷
	SetWindowText(hWnd, m_caption.c_str());

	// vOXo[͈̔͂
	HWND hProgessBar = GetDlgItem(hWnd, IDC_PROGRESS_BAR);
	SendMessage(hProgessBar, PBM_SETRANGE, 0, MAKELPARAM(0, 100));

	// ݒs
	SetStep(0);

	return TRUE;
}

//----------------------------------------------------------------------
// WM_COMMAND nh
//----------------------------------------------------------------------

void CProgressDlg::OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify)
{
	switch (codeNotify) {
	case WM_CLOSE_PROCESS_DIALOG:
		::EndDialog(hWnd, idCtl);
		return;
	case WM_TERMINATE_PROCESS_DIALOG:
		// {^gȂ悤ɂ
		HWND hWndCancel = GetDlgItem(hWnd, IDCANCEL);
		EnableWindow(hWndCancel, FALSE);
		return;
	}

	switch (idCtl) {
	case IDCANCEL:
		m_bCancel = true;
		break;
	}
}

//----------------------------------------------------------------------
// WM_CLOSE nh
//----------------------------------------------------------------------

void CProgressDlg::OnClose(HWND hwnd)
{
	m_bCancel = true;
}

//----------------------------------------------------------------------
// i\
//----------------------------------------------------------------------

void CProgressDlg::SetStep(int step)
{
	DoEvents();

	// vOXo[ݒ肷
	int pos = 0;
	if (m_stepMax <= step) {
		pos = 100;
	} else if (0 < m_stepMax) {
		pos = (int) (step * 100.0 / m_stepMax);
	}

	// NOTE: Windows Vista Ȍł̃vOXo[̐i\̒x邽߂ɁA
	//       UPXebv傫lݒ肵ɁAڕW̒lݒ肵ĂB

	HWND hProgessBar = GetDlgItem(m_hDlg, IDC_PROGRESS_BAR);
	if (pos < 100) {
		SendMessage(hProgessBar, PBM_SETPOS, pos+1, 0);
		SendMessage(hProgessBar, PBM_SETPOS, pos, 0);
	} else {
		SendMessage(hProgessBar, PBM_SETRANGE, 0, MAKELPARAM(0, 101));
		SendMessage(hProgessBar, PBM_SETPOS, pos+1, 0);
		SendMessage(hProgessBar, PBM_SETRANGE, 0, MAKELPARAM(0, 100));
	}


	// ieLXgݒ肷
	std::string progressMsg = CResourceManager::FormatResourceString(IDS_MSG_PROGRESS_TEXT, step, m_stepMax);
	HWND hProgressText = GetDlgItem(m_hDlg, IDC_PROGRESS_TEXT);
	SendMessage(hProgressText, WM_SETTEXT, 0, (LPARAM) progressMsg.c_str());

	DoEvents();
}

//----------------------------------------------------------------------
// Cxg[v
//----------------------------------------------------------------------

void CProgressDlg::DoEvents()
{
	MSG msg;

	while (PeekMessage(&msg, 0, 0, 0, PM_REMOVE)) {
		if (msg.message == WM_QUIT) {
			break;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}

