#pragma once

#include <string>
#include <vector>

////////////////////////////////////////////////////////////////////////
// }N
////////////////////////////////////////////////////////////////////////

// obt@̖ '\0' ݒ肷
#define FORCE_ASCIZ(buffer_) buffer_[sizeof((buffer_)) - 1] = '\0'

// obt@̖ '\0' ݒ肷
#define FORCE_ASCIZ_LEN(buffer_, length_) buffer_[(length_) - 1] = '\0'

////////////////////////////////////////////////////////////////////////
// [eBeBQ
////////////////////////////////////////////////////////////////////////

class Util
{
public:
	// O̎w蕶Q
	static std::string Trim(std::string& str, const char* removechs = " \t\r\n");
	static std::string Trim(const char* pstr, const char* removechs = " \t\r\n");
private:
	// Ԃ
	static bool IsSameChr(const char* pStr1, int mbType1, const char* pStr2, int mbType2);
	// w̕Qɑ݂邩Ԃ
	static bool IsExistChs(const char* pStr, int mbType, const char* chs);
public:
	// w̕ŏIĂ邩ǂԂ
	static bool EndsWith(std::string& targetStr, char* pstr);
	// pX؂ŏIĂ邩ǂԂ
	static bool EndsWithPathDelimiter(std::string& targetStr);
	// u
	static void Replace(std::string& targetStr, std::string strOld, std::string strNew);
	// sR[h CR + LF ɓꂷ
	static void SameCrLf(std::string& targetStr);
	// wb_TĈʒuԂ
	static bool GetHeaderFieldPosition(const char* pMail, const char* pHeaderFieldName, int* pHeaderFieldNameStart, int* pHeaderFieldNameEnd, int* pHeaderFieldBodyStart, int* pHeaderFieldBodyEnd);
	// wb_tB[hɑΉwb_tB[h{fBԂ
	static std::string Util::GetHeaderFieldBody(const char* pMail, const char* pHeaderFieldName, bool* pbFind = 0);
	//  True, False  bool l𓾂
	static bool GetBoolean(std::string& itemValue, bool defaultValue = false);
	// bool l當 True, False 𓾂
	static std::string GetBooleanStr(bool value);
	// HANDLE ɏ
	static BOOL WriteToFile(HANDLE hHandle, const char* lpBuffer, DWORD nNumberOfBytesToWrite);
	// 񂪉p݂̂ō\Ă邩Ԃ
	static bool IsAlnumString(const char* str);
	// sapm \wb_ǉV[f[^쐬
	static bool AddSpamHeader(const char* pMail, int mailLength, const std::string* pSpamHeaderFieldName, const std::string* pSpamHeader, std::vector<char>* pMailNew);
	// spam \wb_폜V[f[^쐬
	static bool RemoveSpamHeader(const char* pMail, int mailLength, const std::string* pSpamHeaderFieldName, std::vector<char>* pMailNew);
	// w̃EBhEeEBhE̒Ɉړ
	static void CenterWindow(HWND hWndParent, HWND hWnd);
	// Becky! ̃tH_ƂĐʂ
	static BOOL IsValidBeckyFolder(std::string folderId);
	// '@' ȍ~̕ԂBȂꍇ͋󕶎Ԃ
	static std::string GetAtNext(const char* email);
	// RRg[o[W 6 ȍ~gpĂ邩Ԃ
	static bool IsCommonCtrlVersion6();
	// EBhEe[}̑
	static HRESULT SetWindowTheme(HWND hWnd, LPCWSTR pszSubAppName, LPCWSTR pszSubIdList);
	// EBhẼo[W𓾂
	static BOOL GetVersionEx(LPOSVERSIONINFO lpVersionInfo);
	// EBhẼo[W 5.1 zĂ邩Ԃ
	static bool IsOverVersion5_1();
};

////////////////////////////////////////////////////////////////////////
// CRITICAL_SECTION ̃bN/AbNp
////////////////////////////////////////////////////////////////////////

class CSLock {
public:
	// RXgN^
	CSLock(CRITICAL_SECTION* pcs);
	// fXgN^
	~CSLock();

private:
	// CRITICAL_SECTION
	CRITICAL_SECTION* m_pcs;
};

////////////////////////////////////////////////////////////////////////
// EFCgJ[\\
////////////////////////////////////////////////////////////////////////

class CWaitCursor {
public:
	// RXgN^
	CWaitCursor();
	// fXgN^
	~CWaitCursor();
	// ɖ߂
	void Restore();

private:
	HCURSOR m_hPrevCursor;
};

////////////////////////////////////////////////////////////////////////
// t@Co[W擾
////////////////////////////////////////////////////////////////////////

typedef struct LANGANDCODEPAGE_ {
	WORD wLanguage;
	WORD wCodePage;
} LANGANDCODEPAGE;

class CFileVersionInfo
{
public:
	// RXgN^
	CFileVersionInfo(HMODULE hModule);

public:
	// CompanyName 擾
	std::string GetCompanyName();
	// ProductName 擾
	std::string GetProductName();
	// ProductVersion 擾
	std::string GetProductVersion();
	// Comments 擾
	std::string GetComments();

private:
	// o[W񂩂l擾
	BOOL QueryValue(char* name, std::string* value);

private:
	// o[Wi[
	std::vector<unsigned char> m_verInfo;

	// ꂨуR[hy[Wւ̎QƂێ
	LANGANDCODEPAGE* m_placp;
	UINT m_lenlacp;
};

/////////////////////////////////////////////////////////////////////////////
// tH_IEBhE
/////////////////////////////////////////////////////////////////////////////

class CBrowseBeckyFolderDlg
{
public:
	// IꂽpX擾
	std::string GetFolderPath();
	// \
	int DoModal(HWND hWndOwner, char* rootFolder, char* selFolder, char* pTitle);

private:
	// R[obN֐
	static int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData);

private:
	// IꂽpXێ
	std::string m_folderPath;
};

/////////////////////////////////////////////////////////////////////////////
// \[X擾p
/////////////////////////////////////////////////////////////////////////////

class CResourceManager {
public:
	// 
	static void Initialize(HINSTANCE hInstance, char* programFolder);
	// 
	static void Release();

public:
	// dll ̃CX^XnhԂ
	static HINSTANCE GetMainInstance();

public:
	// _CAO\[X[h邽߂̃CX^Xnh𓾂
	static HINSTANCE GetDialogInstanceHandle(LPCTSTR lpTemplate);
	// \[XtH[}bgĕԂ
	static std::string FormatResourceString(UINT uID, ...);

public:
	// [__CAO{bNX쐬
	static INT_PTR DlgBox(LPCSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc);
	// [hX_CAO{bNX쐬
	static HWND CreateDlg(LPCSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc); 
	// ACR[h
	static HICON LoadIconImage(LPCTSTR lpszName, int cxDesired, int cyDesired, UINT fuLoad);
	// rbg}bv[h
	static HBITMAP LoadBitmapImage(LPCTSTR lpszName, int cxDesired, int cyDesired, UINT fuLoad);

private:
	// \[XێĂCX^XnhԂ
	static HINSTANCE GetInstanceHandle(LPCTSTR lpName, LPCTSTR lpType);
	// 񃊃\[X[h
	static int LoadStringResource(UINT uID, LPSTR lpBuffer, int cchBufferMax);

private:
	// dll ̃CX^Xnh
	static HINSTANCE s_hInstance;
	// \[Xp dll ̃CX^Xnh
	static HINSTANCE s_hResourceInstance;
};
